Package org.optaplanner.core.impl.score.stream.drools.common

## Class TriLeftHandSide<A,​B,​C>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.drools.common.TriLeftHandSide<A,​B,​C>

- Type Parameters:
    `A` - generic type of the first resulting variable
    `B` - generic type of the second resulting variable
    `C` - generic type of the third resulting variable

      public final class TriLeftHandSide<A,​B,​C>
      extends Object

  Represents the left hand side of a Drools rule, the result of which are three variables. For more, see `UniLeftHandSide` and `BiLeftHandSide`.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected DroolsVariableFactory` | `variableFactory` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `TriLeftHandSide​(PatternVariable<A,​?,​?> patternVariableA, PatternVariable<B,​?,​?> patternVariableB, PatternVariable<C,​?,​?> patternVariableC, DroolsVariableFactory variableFactory)` |
    `protected` | `TriLeftHandSide​(TriLeftHandSide<A,​B,​C> leftHandSide, PatternVariable<C,​?,​?> patternVariable)` |
    `protected` | `TriLeftHandSide​(org.optaplanner.core.impl.score.stream.drools.common.TriRuleContext<A,​B,​C> ruleContext, PatternVariable<A,​?,​?> patternVariableA, PatternVariable<B,​?,​?> patternVariableB, PatternVariable<C,​?,​?> patternVariableC, DroolsVariableFactory variableFactory)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<D> TriLeftHandSide<A,​B,​C>` | `andExists​(Class<D> dClass, QuadJoiner<A,​B,​C,​D>[] joiners)` |
    `TriLeftHandSide<A,​B,​C>` | `andFilter​(TriPredicate<A,​B,​C> predicate)` |
    `<NewA> UniLeftHandSide<NewA>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMapping)` |
    `<NewA,​NewB> BiLeftHandSide<NewA,​NewB>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB)` |
    `<NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB, TriFunction<A,​B,​C,​NewC> keyMappingC)` |
    `<NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB, TriFunction<A,​B,​C,​NewC> keyMappingC, TriFunction<A,​B,​C,​NewD> keyMappingD)` |
    `<NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB, TriFunction<A,​B,​C,​NewC> keyMappingC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `<NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)` |
    `<NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriFunction<A,​B,​C,​NewB> keyMappingB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `<NewA,​NewB> BiLeftHandSide<NewA,​NewB>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB)` |
    `<NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)` |
    `<NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `<NewA> UniLeftHandSide<NewA>` | `andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collector)` |
    `<NewA,​NewB> BiLeftHandSide<NewA,​NewB>` | `andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB)` |
    `<NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC>` | `andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)` |
    `<NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD>` | `andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA, TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB, TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC, TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)` |
    `<D> QuadLeftHandSide<A,​B,​C,​D>` | `andJoin​(UniLeftHandSide<D> right, QuadJoiner<A,​B,​C,​D> joiner)` |
    `<NewA> UniLeftHandSide<NewA>` | `andMap​(TriFunction<A,​B,​C,​NewA> mapping)` |
    `<D> TriLeftHandSide<A,​B,​C>` | `andNotExists​(Class<D> dClass, QuadJoiner<A,​B,​C,​D>[] joiners)` |
    `<Solution_> RuleBuilder<Solution_>` | `andTerminate()` |
    `<Solution_> RuleBuilder<Solution_>` | `andTerminate​(ToIntTriFunction<A,​B,​C> matchWeighter)` |
    `<Solution_> RuleBuilder<Solution_>` | `andTerminate​(ToLongTriFunction<A,​B,​C> matchWeighter)` |
    `<Solution_> RuleBuilder<Solution_>` | `andTerminate​(TriFunction<A,​B,​C,​BigDecimal> matchWeighter)` |
    `protected static org.drools.model.view.ViewItem<?>` | `buildAccumulate​(org.drools.model.view.ViewItem<?> innerAccumulatePattern, org.drools.model.functions.accumulate.AccumulateFunction... accFunctions)` |
    `protected static <A,​B> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<BiTuple<A,​B>>` | `decompose​(org.drools.model.Variable<BiTuple<A,​B>> primaryVariable, org.drools.model.view.ViewItem<?> prerequisitePattern, org.drools.model.Variable<A> boundVarA, org.drools.model.Variable<B> boundVarB)` | Create a `DirectPatternVariable` on `BiTuple` with pre-made bindings for its components variables.
    `protected static <A,​B,​C,​D> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<QuadTuple<A,​B,​C,​D>>` | `decompose​(org.drools.model.Variable<QuadTuple<A,​B,​C,​D>> primaryVariable, org.drools.model.view.ViewItem<?> prerequisitePattern, org.drools.model.Variable<A> boundVarA, org.drools.model.Variable<B> boundVarB, org.drools.model.Variable<C> boundVarC, org.drools.model.Variable<D> boundVarD)` | Create a `DirectPatternVariable` on `QuadTuple` with pre-made bindings for its components variables.
    `protected static <A,​B,​C> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<TriTuple<A,​B,​C>>` | `decompose​(org.drools.model.Variable<TriTuple<A,​B,​C>> primaryVariable, org.drools.model.view.ViewItem<?> prerequisitePattern, org.drools.model.Variable<A> boundVarA, org.drools.model.Variable<B> boundVarB, org.drools.model.Variable<C> boundVarC)` | Create a `DirectPatternVariable` on `TriTuple` with pre-made bindings for its components variables.
    `protected static org.drools.model.Index.ConstraintType` | `getConstraintType​(JoinerType type)` |
    `protected PatternVariable<A,​?,​?>` | `getPatternVariableA()` |
    `protected PatternVariable<B,​?,​?>` | `getPatternVariableB()` |
    `protected PatternVariable<C,​?,​?>` | `getPatternVariableC()` |
    `protected static org.drools.model.view.ViewItem<?>` | `joinViewItemsWithLogicalAnd​(PatternVariable<?,​?,​?>... patternVariables)` |
    `protected static List<org.drools.model.view.ViewItem<?>>` | `mergeViewItems​(PatternVariable<?,​?,​?>... patternVariables)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### variableFactory

          protected final DroolsVariableFactory variableFactory

  - ### Constructor Detail

    - #### TriLeftHandSide

          protected TriLeftHandSide​(PatternVariable<A,​?,​?> patternVariableA,
                                    PatternVariable<B,​?,​?> patternVariableB,
                                    PatternVariable<C,​?,​?> patternVariableC,
                                    DroolsVariableFactory variableFactory)

    - #### TriLeftHandSide

          protected TriLeftHandSide​(org.optaplanner.core.impl.score.stream.drools.common.TriRuleContext<A,​B,​C> ruleContext,
                                    PatternVariable<A,​?,​?> patternVariableA,
                                    PatternVariable<B,​?,​?> patternVariableB,
                                    PatternVariable<C,​?,​?> patternVariableC,
                                    DroolsVariableFactory variableFactory)

    - #### TriLeftHandSide

          protected TriLeftHandSide​(TriLeftHandSide<A,​B,​C> leftHandSide,
                                    PatternVariable<C,​?,​?> patternVariable)

  - ### Method Detail

    - #### getPatternVariableA

          protected PatternVariable<A,​?,​?> getPatternVariableA()

    - #### getPatternVariableB

          protected PatternVariable<B,​?,​?> getPatternVariableB()

    - #### getPatternVariableC

          protected PatternVariable<C,​?,​?> getPatternVariableC()

    - #### andFilter

          public TriLeftHandSide<A,​B,​C> andFilter​(TriPredicate<A,​B,​C> predicate)

    - #### andExists

          public <D> TriLeftHandSide<A,​B,​C> andExists​(Class<D> dClass,
                                                                  QuadJoiner<A,​B,​C,​D>[] joiners)

    - #### andNotExists

          public <D> TriLeftHandSide<A,​B,​C> andNotExists​(Class<D> dClass,
                                                                     QuadJoiner<A,​B,​C,​D>[] joiners)

    - #### andJoin

          public <D> QuadLeftHandSide<A,​B,​C,​D> andJoin​(UniLeftHandSide<D> right,
                                                                         QuadJoiner<A,​B,​C,​D> joiner)

    - #### andGroupBy

          public <NewA> UniLeftHandSide<NewA> andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collector)

    - #### andGroupBy

          public <NewA,​NewB> BiLeftHandSide<NewA,​NewB> andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA,
                                                                              TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB)

    - #### andGroupBy

          public <NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC> andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA,
                                                                                                     TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                                                                     TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)

    - #### andGroupBy

          public <NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> andGroupBy​(TriConstraintCollector<A,​B,​C,​?,​NewA> collectorA,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### andGroupBy

          public <NewA> UniLeftHandSide<NewA> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMapping)

    - #### andGroupBy

          public <NewA,​NewB> BiLeftHandSide<NewA,​NewB> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                              TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB)

    - #### andGroupBy

          public <NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                     TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                                                                     TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)

    - #### andGroupBy

          public <NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewB> collectorB,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### andGroupBy

          public <NewA,​NewB> BiLeftHandSide<NewA,​NewB> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                              TriFunction<A,​B,​C,​NewB> keyMappingB)

    - #### andGroupBy

          public <NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                     TriFunction<A,​B,​C,​NewB> keyMappingB,
                                                                                                     TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC)

    - #### andGroupBy

          public <NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                                            TriFunction<A,​B,​C,​NewB> keyMappingB,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewC> collectorC,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### andGroupBy

          public <NewA,​NewB,​NewC> TriLeftHandSide<NewA,​NewB,​NewC> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                     TriFunction<A,​B,​C,​NewB> keyMappingB,
                                                                                                     TriFunction<A,​B,​C,​NewC> keyMappingC)

    - #### andGroupBy

          public <NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                                            TriFunction<A,​B,​C,​NewB> keyMappingB,
                                                                                                                            TriFunction<A,​B,​C,​NewC> keyMappingC,
                                                                                                                            TriConstraintCollector<A,​B,​C,​?,​NewD> collectorD)

    - #### andGroupBy

          public <NewA,​NewB,​NewC,​NewD> QuadLeftHandSide<NewA,​NewB,​NewC,​NewD> andGroupBy​(TriFunction<A,​B,​C,​NewA> keyMappingA,
                                                                                                                            TriFunction<A,​B,​C,​NewB> keyMappingB,
                                                                                                                            TriFunction<A,​B,​C,​NewC> keyMappingC,
                                                                                                                            TriFunction<A,​B,​C,​NewD> keyMappingD)

    - #### andMap

          public <NewA> UniLeftHandSide<NewA> andMap​(TriFunction<A,​B,​C,​NewA> mapping)

    - #### andTerminate

          public <Solution_> RuleBuilder<Solution_> andTerminate()

    - #### andTerminate

          public <Solution_> RuleBuilder<Solution_> andTerminate​(ToIntTriFunction<A,​B,​C> matchWeighter)

    - #### andTerminate

          public <Solution_> RuleBuilder<Solution_> andTerminate​(ToLongTriFunction<A,​B,​C> matchWeighter)

    - #### andTerminate

          public <Solution_> RuleBuilder<Solution_> andTerminate​(TriFunction<A,​B,​C,​BigDecimal> matchWeighter)

    - #### getConstraintType

          protected static org.drools.model.Index.ConstraintType getConstraintType​(JoinerType type)

    - #### joinViewItemsWithLogicalAnd

          protected static org.drools.model.view.ViewItem<?> joinViewItemsWithLogicalAnd​(PatternVariable<?,​?,​?>... patternVariables)

    - #### mergeViewItems

          protected static List<org.drools.model.view.ViewItem<?>> mergeViewItems​(PatternVariable<?,​?,​?>... patternVariables)

    - #### decompose

          protected static <A,​B> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<BiTuple<A,​B>> decompose​(org.drools.model.Variable<BiTuple<A,​B>> primaryVariable,
                                                                                                                                                org.drools.model.view.ViewItem<?> prerequisitePattern,
                                                                                                                                                org.drools.model.Variable<A> boundVarA,
                                                                                                                                                org.drools.model.Variable<B> boundVarB)

      Create a `DirectPatternVariable` on `BiTuple` with pre-made bindings for its components variables.
      Type Parameters:
        `A` - generic type of the first bound variable
        `B` - generic type of the second bound variable
      Parameters:
        `primaryVariable` - never null
        `prerequisitePattern` - never null, pattern required to construct the variable
        `boundVarA` - never null, `BiTuple.a`
        `boundVarB` - never null, `BiTuple.b`
      Returns:
        never null

    - #### decompose

          protected static <A,​B,​C> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<TriTuple<A,​B,​C>> decompose​(org.drools.model.Variable<TriTuple<A,​B,​C>> primaryVariable,
                                                                                                                                                                 org.drools.model.view.ViewItem<?> prerequisitePattern,
                                                                                                                                                                 org.drools.model.Variable<A> boundVarA,
                                                                                                                                                                 org.drools.model.Variable<B> boundVarB,
                                                                                                                                                                 org.drools.model.Variable<C> boundVarC)

      Create a `DirectPatternVariable` on `TriTuple` with pre-made bindings for its components variables.
      Type Parameters:
        `A` - generic type of the first bound variable
        `B` - generic type of the second bound variable
        `C` - generic type of the third bound variable
      Parameters:
        `primaryVariable` - never null
        `prerequisitePattern` - never null, pattern required to construct the variable
        `boundVarA` - never null, `TriTuple.a`
        `boundVarB` - never null, `TriTuple.b`
        `boundVarC` - never null, `TriTuple.c`
      Returns:
        never null

    - #### decompose

          protected static <A,​B,​C,​D> org.optaplanner.core.impl.score.stream.drools.common.DirectPatternVariable<QuadTuple<A,​B,​C,​D>> decompose​(org.drools.model.Variable<QuadTuple<A,​B,​C,​D>> primaryVariable,
                                                                                                                                                                                  org.drools.model.view.ViewItem<?> prerequisitePattern,
                                                                                                                                                                                  org.drools.model.Variable<A> boundVarA,
                                                                                                                                                                                  org.drools.model.Variable<B> boundVarB,
                                                                                                                                                                                  org.drools.model.Variable<C> boundVarC,
                                                                                                                                                                                  org.drools.model.Variable<D> boundVarD)

      Create a `DirectPatternVariable` on `QuadTuple` with pre-made bindings for its components variables.
      Type Parameters:
        `A` - generic type of the first bound variable
        `B` - generic type of the second bound variable
        `C` - generic type of the third bound variable
        `D` - generic type of the fourth bound variable
      Parameters:
        `primaryVariable` - never null
        `prerequisitePattern` - never null, pattern required to construct the variable
        `boundVarA` - never null, `QuadTuple.a`
        `boundVarB` - never null, `QuadTuple.b`
        `boundVarC` - never null, `QuadTuple.c`
        `boundVarD` - never null, `QuadTuple.d`
      Returns:
        never null

    - #### buildAccumulate

          protected static org.drools.model.view.ViewItem<?> buildAccumulate​(org.drools.model.view.ViewItem<?> innerAccumulatePattern,
                                                                             org.drools.model.functions.accumulate.AccumulateFunction... accFunctions)